<?php
function database_connect()
{
	return true;
}

function release_exists($release)
{
	return file_exists(getCRCPath()."$release.crc");
}

function insert_release($release,$nbfiles,$realpath,$virtualpath)
{
	if(!file_exists(getCRCPath()))
	{
		@mkdir(getCRCPath(),0777);
	}

	if(!$crc=fopen(getCRCPath()."$release.crc","w+"))
	{
		return false;
	}
	else
	{
		fclose($crc);
		return true;
	}
}

function insert_file($release,$filename,$filesize,$speed,$racer,$racergroup)
{
	global $fullpath;

	$alllines=join("",file(getCRCPath()."$release.crc"));
	if(!stristr($alllines,$filename))
	{
		$tf=fopen(getCRCPath()."$release.crc","a");
		fwrite($tf,"$racer|$racergroup|$filename|$filesize|$speed\n");
		fclose($tf);
	}
	unset($alllines);
}

function request_raceinfo($release)
{
	global $fullpath;

	$crclines=file(getCRCPath()."$release.crc");
	
	sort($crclines);
	
	$raceinfo=array();
	foreach($crclines as $row)
	{
		$row=str_replace("\n","",$row);
		$row=explode("|",$row);
		$raceinfo[]=$row;
	}

	return $raceinfo;
}

function update_release_nbfiles()
{
	return true;
}

function update_release_status()
{
	return true;
}

function delete_file($release,$filename)
{
	$found=false;
	$alllines=file(getCRCPath()."$release.crc");

	if($tf=fopen(getCRCPath()."$release.crc","w"))
	{
		foreach($alllines as $line)
		{
			if(!stristr($line,$filename))
			{
				fwrite($tf,"$line");
			}
			else
			{
				$found=true;
			}
		}
		fclose($tf);
	}
	return $found;
}

function delete_release($release)
{
	@unlink(getCRCPath()."$release.crc");
}

function database_disconnect()
{
	return true;
}

function getCRCPath()
{
	global $CRCPATH,$SCRIPTPATH;
	return (file_exists($CRCPATH)&&isset($CRCPATH)&&$CRCPATH!="")?$CRCPATH:"${SCRIPTPATH}RaceInfo/";

}
?>
