<?php
function calculate_raceinfo(&$racersInfos,&$groupsInfos)
{
	global $release;

	$raceinfo=request_raceinfo($release);

	$oldname="";
	$z=-1;

	global $totavgspeed,$sizefilesup,$nbfilesup;
	$totavgspeed=0;
	$sizefilesup=0;
	$nbfilesup=0;

	global $maxspeed,$usermax,$groupmax;
	global $minspeed,$usermin,$groupmin;

	$maxspeed=0;
	$minspeed=0;

	$racersInfos["racer"]=array();
	$racersInfos["group"]=array();
	$racersInfos["nbfiles"]=array();
	$racersInfos["nbbytes"]=array();
	$racersInfos["avgspeed"]=array();

	$groupsInfos["group"]=array();
	$groupsInfos["nbracers"]=array();
	$groupsInfos["nbfiles"]=array();
	$groupsInfos["nbbytes"]=array();
	$groupsInfos["percentage"]=array();
	$groupsInfos["avgspeed"]=array();

	foreach($raceinfo as $newname)
	{
		// processing racers infos
		if($maxspeed=0)
		{
			$maxspeed=$minspeed=$newname[4];
			$usermax=$usermin=$newname[0];
			$groupmax=$groupmin=$newname[1];
		}

		if($maxspeed<$newname[4])
		{
			$maxspeed=$newname[4];
			$usermax=$newname[0];
			$groupmax=$newname[1];
		}

		if($minspeed>$newname[4])
		{
			$minspeed=$newname[4];
			$usermin=$newname[0];
			$groupmin=$newname[1];
		}

		if($oldname != $newname[0])
		{
			$z++;
			$racersInfos["racer"][$z]		= $newname[0];
			$racersInfos["group"][$z]		= $newname[1];
			$racersInfos["nbfiles"][$z]=1;
			$racersInfos["nbbytes"][$z]		= $newname[3];
			$racersInfos["avgspeed"][$z]	= $newname[4];

			if($totavgspeed==0)
			{
				$totavgspeed=$newname[4];
			}
			else
			{
				$totavgspeed=round(($sizefilesup+$newname[3]) /
					($sizefilesup/$totavgspeed+$newname[3]/$newname[4]));
			}
			$sizefilesup+=$newname[3];
			$nbfilesup++;
			$oldname=$newname[0];
		}
		else
		{
			$racersInfos["nbfiles"][$z] ++;

			// caculates average speed

			$racersInfos["avgspeed"][$z] = round(($racersInfos["nbbytes"][$z]+$newname[3]) /
				($racersInfos["nbbytes"][$z]/$racersInfos["avgspeed"][$z]+$newname[3]/$newname[4]));
			$racersInfos["nbbytes"][$z] += $newname[3];

			$totavgspeed=round(($sizefilesup+$newname[3]) /
				($sizefilesup/$totavgspeed+$newname[3]/$newname[4]));
			$sizefilesup+=$newname[3];
			$nbfilesup++;
		}

	}
	array_multisort($racersInfos["nbbytes"],SORT_DESC,SORT_NUMERIC,
		$racersInfos["avgspeed"],SORT_DESC,SORT_NUMERIC,
		$racersInfos["racer"],
		$racersInfos["group"],
		$racersInfos["nbfiles"]);

	global $nbfiles;
	if($nbfilesup == $nbfiles)
	{
		update_release_status($release,"COMPLETE");
	}
	else
	{
		if($nbfilesup > $nbfiles)
		{
			update_release_status($release,"WTF ??");
		}
		else
		{
			update_release_status($release,"INCOMPLETE");
		}
	}

	database_disconnect();

	// processing groups infos
	for($i=0;$i<=$z;$i++)
	{
		unset($key);
		$key=array_search($racersInfos["group"][$i],$groupsInfos["group"]);

		if($key!="")
			// group already in groupsInfos
		{
			$groupsInfos["nbracers"][$key]++;
			$groupsInfos["nbfiles"][$key]+=$racersInfos["nbfiles"][$i];
			$groupsInfos["avgspeed"][$key] = round(($groupsInfos["nbbytes"][$key]+$racersInfos["nbbytes"][$i]) /
				($groupsInfos["nbbytes"][$key]/$groupsInfos["avgspeed"][$key]+$racersInfos["nbbytes"][$i]/$racersInfos["avgspeed"][$i]));
			$groupsInfos["nbbytes"][$key]+=$racersInfos["nbbytes"][$i];
			$groupsInfos["percentage"][$key]=($groupsInfos["nbbytes"][$key]/$sizefilesup)*100;
		}
		else
			// new group
		{
			$groupsInfos["group"][]=$racersInfos["group"][$i];
			$groupsInfos["nbracers"][]=1;
			$groupsInfos["nbfiles"][]=$racersInfos["nbfiles"][$i];
			$groupsInfos["percentage"][]=($racersInfos["nbbytes"][$i]/$sizefilesup)*100;
			$groupsInfos["avgspeed"][]=$racersInfos["avgspeed"][$i];
			$groupsInfos["nbbytes"][]=$racersInfos["nbbytes"][$i];
		}
	}
	array_multisort($groupsInfos["nbbytes"],SORT_DESC,SORT_NUMERIC,
		$groupsInfos["avgspeed"],SORT_DESC,SORT_NUMERIC,
		$groupsInfos["group"],
		$groupsInfos["nbracers"],
		$groupsInfos["nbfiles"],
		$groupsInfos["percentage"]);
	$nbuploader=0;

	global $username, $usergroup, $raceLeader, $leadingGroup, $leaderGroup;
	if(sizeof($racersInfos["racer"])>0 && $racersInfos["racer"][0]!="")
	{
		$raceLeader=$racersInfos["racer"][0];
	}
	else
	{
		$raceLeader=$username;
	}

	if(sizeof($racersInfos["group"])>0 && $racersInfos["group"][0]!="")
	{
		$leaderGroup=$racersInfos["group"][0];
	}
	else
	{
		$leaderGroup=$usergroup;
	}

	if(sizeof($groupsInfos["group"])>0 && $groupsInfos["group"][0]!="")
	{
		$leadingGroup=$groupsInfos["group"][0];
	}
	else
	{
		$leadingGroup=$usergroup;
	}
}

function process_raceinfo()
{
	global $fullpath;
	global $filename;
	global $username,$usergroup;
	global $lastSpeed;
	global $release;
	global $SITENAME;
	global $nbfiles;

	global $maxspeed;
	global $minspeed;
	global $usermax;
	global $usermin;
	global $nbfilesup;
	global $sizefilesup;
	global $totavgspeed;
	global $percent;

	$file_idDotDiz="";
	global $DIZINMESSAGEFILE;
	if(isset($DIZINMESSAGEFILE) && $DIZINMESSAGEFILE!="" && file_exists("{$fullpath}file_id.diz"))
	{
		$file_idDotDiz=join("",file("{$fullpath}file_id.diz"));

		if(ini_get("magic_quotes_runtime"))
			$file_idDotDiz=stripslashes($file_idDotDiz);

		$file_idDotDiz=str_replace(chr(0x0D).chr(0x0A),"\n",$file_idDotDiz);
		// fixes a bug I encouter once, the msg file wasnt fully displayed
		// on the client, dunno if its the only fix to do...
		$file_idDotDiz=str_replace(chr(0x1A),"",$file_idDotDiz);
	}

	calculate_raceinfo($racersInfos,$groupsInfos);

	$nbuploader=0;
	$groupsReport=$racersReport="";
	for($i=0;$i<sizeof($racersInfos["racer"]);$i++)
	{
		if($racersInfos["racer"][$i] != "")
		{
			$nbuploader++;

			if($username == $racersInfos["racer"][$i])
			{
				$fileuserindex = $i;
			}
			$nbuppers[$i]=$racersInfos["racer"][$i];

			$racersInfos["percentage"][$i]=($racersInfos["nbbytes"][$i]/$sizefilesup)*100;

			$racersReport.= "| $nbuploader.".sprintf("%-21s", substr($racersInfos["racer"][$i]."/".$racersInfos["group"][$i],0,21)).
				" | ".sprintf("%5s", $racersInfos["nbfiles"][$i]).
				" | ".sprintf("%14s", number_format(($racersInfos["nbbytes"][$i]))).
				" | ".sprintf("%3.2f",$racersInfos["percentage"][$i]).
				" | ".sprintf("%7s", number_format($racersInfos["avgspeed"][$i]))." |\n";

			$racersInfos["nbbytes"][$i]=round(trim($racersInfos["nbbytes"][$i])/1048576,2);
		}
	}
	$racers=$i;

	for($i=0;$i<sizeof($groupsInfos["group"]);$i++)
	{
		$groupsReport.= "| ". ($i+1).".".sprintf("%-14s", substr($groupsInfos["group"][$i],0,14)).
			" | ".sprintf("%6s", $groupsInfos["nbracers"][$i]).
			" | ".sprintf("%5s", $groupsInfos["nbfiles"][$i]).
			" | ".sprintf("%12s", number_format($groupsInfos["nbbytes"][$i])).
			" | ".sprintf("%3.2f",$groupsInfos["percentage"][$i]).
			" | ".sprintf("%7s", number_format($groupsInfos["avgspeed"][$i]))." |\n";
	}


	$percent=round(($nbfilesup/$nbfiles)*100,2);

	$racersTotal= sprintf("%-23s |","Total : $nbuploader").
		sprintf(" %5s |",$nbfilesup).
		sprintf(" %14s |",number_format($sizefilesup)).
		sprintf(" %3.2f |",$percent).
		sprintf(" %7s",number_format($totavgspeed));

	$groupsTotal= sprintf("%-16s |","Total : ".sizeof($groupsInfos["group"])).
		sprintf(" %6s |",$nbuploader).
		sprintf(" %5s |",$nbfilesup).
		sprintf(" %12s |",number_format($sizefilesup)).
		sprintf(" %3.2f |",$percent).
		sprintf(" %7s",number_format($totavgspeed));

	global $CREATEMESSAGEFILE;
	if(isset($CREATEMESSAGEFILE))
	{
		global $MESSAGEFILENAME;
		if(isset($MESSAGEFILENAME) && $MESSAGEFILENAME!="")
			$MESSAGEFILENAME=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MESSAGEFILENAME);
		else
			$MESSAGEFILENAME=".message";

		$tf=fopen("$fullpath{$MESSAGEFILENAME}","w+");
		fwrite($tf,$file_idDotDiz);

		$tempStr=str_pad("$SITENAME Release Info !",51," ",STR_PAD_BOTH);
		fwrite($tf,"\n  ...::( $tempStr )::...\n");
		fwrite($tf,".-===================================================================-.\n");
		fwrite($tf,sprintf("| %-67s |\n","Release : $release"));
		fwrite($tf,sprintf("| %-67s |\n","Last file uped on ".date("m/d/Y")." at ".date("H:i:s")." by $username"));
		fwrite($tf,sprintf("| %-67s |\n","File(s) in release : $nbfiles"));
		fwrite($tf,"`-===================================================================-'\n");

		$tempStr=str_pad("$SITENAME Race Info !",51," ",STR_PAD_BOTH);
		fwrite($tf,"\n  ...::( $tempStr )::...\n");
		fwrite($tf,".-===================================================================-.\n");
		fwrite($tf,"|                       Directory and Race Info                       |\n");
		fwrite($tf,"|-===================================================================-|\n");

		$tempStr=str_pad("Racers :",67," ",STR_PAD_BOTH);
		fwrite($tf,"| $tempStr |\n");
		fwrite($tf,"|-===================================================================-|\n");
		fwrite($tf,"|           Racer         | Files |      Bytes     |   %    |  K/sec  |\n");
		fwrite($tf,"||\n");
		if($racersReport!="")
		{
			fwrite($tf,$racersReport);
		}
		else
		{
			fwrite($tf,"|            N/A          |  N/A  |       N/A      |   N/A  |   N/A   |\n");
		}
		fwrite($tf,"||\n");
		fwrite($tf,"| $racersTotal |\n");
		fwrite($tf,"|-===================================================================-|\n");
		$tempStr=str_pad("Groups :",67," ",STR_PAD_BOTH);
		fwrite($tf,"| $tempStr |\n");
		fwrite($tf,"|-===================================================================-|\n");
		fwrite($tf,"|      Group       | Racers | Files |     Bytes    |   %    |  K/sec  |\n");
		fwrite($tf,"||\n");
		if($groupsReport!="")
		{
			fwrite($tf,$groupsReport);
		}
		else
		{
			fwrite($tf,"|       N/A        |   N/A  |  N/A  |      N/A     |   N/A  |   N/A   |\n");
		}
		fwrite($tf,"||\n");
		fwrite($tf,"| $groupsTotal |\n");
		fwrite($tf,"`-===================================================================-'\n\n");				
		fclose($tf);

		global $MESSAGEFILESOWNER,$MESSAGEFILESRIGHTS,$SCRIPTPATH;
		list($owner,$group)=translateOwnerGrp($MESSAGEFILESOWNER);

		global $aclFiles;
		$aclFiles["releaseDir"]->chmod($MESSAGEFILENAME,$owner,$group,$MESSAGEFILESRIGHTS);
	}

	$output=" Release -> $release \n";
	if($filename!="")
	{
		$output.=" $username upped $filename @ $lastSpeed K/sec \n";
	}
	$output.=" Upload Process : ".trim($nbfilesup)." of ".trim($nbfiles)." File(s) completed (".trim($percent)."%) \n";
	$output.=" Processing done....Now with the stats... \n";

	$output.="-===================================================================-\n";
	$output.=sprintf(" %-67s \n"," Racers : ");
	$output.="-===================================================================-\n";
	$output.="           Racer         | Files |      Bytes     |   %    |  K/sec  \n";
	$output.="\n";
	// modify the racersReport so that it can be used with outputProgress
	if($racersReport!="")
	{
		$racersReport=str_replace("|\n","\n","\n$racersReport");
		$racersReport=str_replace("\n|","\n","$racersReport");
		$output.=$racersReport;
	}
	else
	{
		$output.="            N/A          |  N/A  |       N/A      |   N/A  |   N/A   \n";
	}
	$output.="\n";
	$output.=" $racersTotal \n";
	$output.="-===================================================================-\n";
	$output.=sprintf(" %-67s \n"," Groups : ");
	$output.="-===================================================================-\n";
	$output.="      Group       | Racers | Files |     Bytes    |   %    |  K/sec  \n";
	$output.="\n";
	// modify the groupsReport so that it can be used with outputProgress
	if($groupsReport!="")
	{
		$groupsReport=str_replace("|\n","\n","\n$groupsReport");
		$groupsReport=str_replace("\n|","\n","$groupsReport");
		$output.=$groupsReport;
	}
	else
	{
		$output.="       N/A        |   N/A  |  N/A  |      N/A     |   N/A  |   N/A   \n";
	}
	$output.="\n";
	$output.=" $groupsTotal \n";

	outputProgress($output,"w+");

	global $PFCOMPLETEMODEL, $PFINCOMPLETEMODEL;	

	$output="";
	if($percent>=100)
	{
		global $COMPLETEMODEL;
		delIncompleteTags();
		createTag($fullpath.translateModel($COMPLETEMODEL,false),2);
		if(isset($PFCOMPLETEMODEL))
		{
			$output=translateModel($PFCOMPLETEMODEL,true);
		}
	}
	else
	{
		global $INCOMPLETEMODEL,$PARENTINCOMPLETEMODEL;
		if($nbfiles)
		{
			delIncompleteTags();

			if(stristr($INCOMPLETEMODEL,"incomplete"))
			{
				createTag($fullpath.translateModel($INCOMPLETEMODEL,false),0);
			}

			$parentFolder=dirname($fullpath)."\\";

			global $multiCD;
			if(isset($multiCD) && $multiCD)
			{
				$parentFolder=dirname($parentFolder)."\\";
			}

			if(stristr($PARENTINCOMPLETEMODEL,"incomplete") && stristr($PARENTINCOMPLETEMODEL,"%r"))
			{
				createTag($parentFolder.translateModel($PARENTINCOMPLETEMODEL,false),1);
			}
		}

		if(isset($PFINCOMPLETEMODEL))
		{
			$output=translateModel($PFINCOMPLETEMODEL,true);
		}
	}
	if($output!="")
		outputProgress($output,"a");

}

function translateOwnerGrp($option)
{
	global $username,$usergroup;
	global $raceLeader,$leaderGroup;

	switch($option)
	{
	case '1':
		$owner=$username;
		$group=$usergroup;
		break;
	case '2':
		$owner=$raceLeader;
		$group=$leaderGroup;
		break;
	default:
		list($owner,$group)=explode(",",$option);
		if($owner=="")
			$owner="phpZipScript";
		if($group=="")
			$group="script";
	}

	return array($owner,$group);
}


function outputProgress($text,$mode="w+",$filebase="ask-onFileUploaded",$accept=1)
{
	if($text=="")
		return;

	global $scriptVersion;

	global $GCID;
	global $RAIDENPATH;

	$progress="{$RAIDENPATH}output/$filebase.$GCID";

	$fp=fopen($progress,$mode);

	$lines=explode("\n",$text);

	if($mode!="a")
	{
		fwrite($fp,"$accept\n"); // dummy line due to ask mechanism, isnt used by raiden
		fwrite($fp,".-===================================================================-.\n");
		fwrite($fp,"| ".str_pad(".:|:.-phpZipScript $scriptVersion by Leblanc-.:|:.",67," ",STR_PAD_BOTH)." |\n");
		fwrite($fp,"|---------------------------------------------------------------------|\n");
		foreach($lines as $line)
		{
			fwrite($fp,	str_replace("%","%%",sprintf("|%-69s|\n","$line")));
		}
		fwrite($fp,"`-===================================================================-'\n");
	}
	else
	{
		foreach($lines as $line)
		{
			fwrite($fp,str_replace("%","%%",$line."\n"));
		}
	}
	fclose($fp);
}

function createTags()
{

}

function createTag($path,$type)
{
	global $TAGSMODES,$TAGSOWNER,$TAGSOWNERRIGHTS,$TAGSGROUPRIGHTS,$TAGSWORLDRIGHTS;
	global $SCRIPTPATH;
	global $aclFiles;

	switch($TAGSMODES[$type])
	{
	case '1':
		fclose(fopen($path,"w+"));
		break;
	case '2':
		mkdir($path, 0700);
		break;
	}

	list($owner,$group)=translateOwnerGrp($TAGSOWNER);

	$mod=$TAGSOWNERRIGHTS[$type].$TAGSGROUPRIGHTS[$type].$TAGSWORLDRIGHTS[$type];

	if($type==1)
	{
		$aclFiles["parentDir"]->chmod(basename($path),$owner,$group,$mod);
	}
	else
	{
		$aclFiles["releaseDir"]->chmod(basename($path),$owner,$group,$mod);
	}
	//	exec("{$SCRIPTPATH}chmod.exe $mod $owner $group \"$path\"");
}

function delIncompleteTags()
{
	global $fullpath;
	global $release;
	global $NOFILEIDMODEL;
	global $BADFILEIDMODEL;
	global $TAGSMODES;
	global $aclFiles;

	if($TAGSMODES[0]!=0 || $TAGSMODES[3]!=0 || $TAGSMODES[4]!=0)
	{
		$handle=opendir($fullpath);
		while($file = readdir($handle))
		{
			if( stristr($file,"incomplete") )
			{
				delTag($fullpath.$file,0);
				$aclFiles["releaseDir"]->delete($file);
			} else if( stristr($file,"complete") )
			{
				delTag($fullpath.$file,2);
				$aclFiles["releaseDir"]->delete($file);
			} else if( $file==$BADFILEIDMODEL)
			{
				delTag($fullpath.$file,3);
				$aclFiles["releaseDir"]->delete($file);
			} else if( $file==$NOFILEIDMODEL)
			{
				delTag($fullpath.$file,4);
				$aclFiles["releaseDir"]->delete($file);
			}
		}
		closedir($handle);
	}

	if($TAGSMODES[1]!=0)
	{
		global $MODELSPACECHAR;

		$tempRelease=$release;

		if(isset($MODELSPACECHAR))
		{
			$tempRelease=str_replace(" ",$MODELSPACECHAR,$tempRelease);
		}

		//		$parentFolder=substr($fullpath,0,strrpos(substr($fullpath,0,-1),"\\"))."\\";
		$parentFolder=dirname($fullpath)."\\";

		global $multiCD;
		if(isset($multiCD) && $multiCD)
		{
			$parentFolder=dirname($parentFolder)."\\";
		}

		$handle=opendir($parentFolder);
		while($file = readdir($handle))
		{
			if( stristr($file,"incomplete") && stristr($file,$tempRelease))
			{
				delTag($parentFolder.$file,1);
				$aclFiles["parentDir"]->delete($file);
			}
		}
		closedir($handle);
	}
}

function delTag($tagPath,$type)
{
	global $TAGSMODES;
	switch($TAGSMODES[$type])
	{
	case 1:
		@unlink($tagPath);
		break;
	case 2:
		@rmdir($tagPath);
		break;
	}
}

function translateModel($model,$leaveWrongChars)
{
	global $totavgspeed;
	global $SITENAME;
	global $nbfilesup;
	global $nbfiles;
	global $sizefilesup;
	global $percent;
	global $release;
	global $raceLeader;
	global $PROGRESSBARLENGTH;
	global $MODELSPACECHAR;
	global $tagline;
	global $leadingGroup, $leaderGroup;

	$wrongChars=array("\\","/","*",":","?","\"","<",">","|");

	$sizeMeg=round($sizefilesup/1024/1024,1);

	$nbD = round($percent*$PROGRESSBARLENGTH/100);

	$PROGRESSFILLEDCHAR=isset($PROGRESSFILLEDCHAR)?$PROGRESSFILLEDCHAR:"#";
	$PROGRESSBLANKCHAR=isset($PROGRESSBLANKCHAR)?$PROGRESSBLANKCHAR:"=";

	$progressBar="";
	for($i=0;$i<$PROGRESSBARLENGTH;$i++)
	{
		if($i<$nbD)
		{
			global $PROGRESSFILLEDCHAR;

			$progressBar.=$PROGRESSFILLEDCHAR;
		}
		else
		{
			global $PROGRESSBLANKCHAR;
			$progressBar.=$PROGRESSBLANKCHAR;
		}
	}

	$patterns=array("%s","%%","%v","%n",
		"%N","%b","%M","%p",
		"%d","%m","%y","%Y",
		"%r","%P","%w","%T",
		"%g","%G","%i");

	$replacements=array($SITENAME,"%",$totavgspeed,trim($nbfilesup),
		$nbfiles,trim($sizefilesup),$sizeMeg,number_format($percent,2),
		date("d"),date("m"),date("y"),date("Y"),
		$release,$progressBar,$raceLeader,trim($tagline),
		$leaderGroup,$leadingGroup,intval($percent));
	$model=str_replace($patterns,$replacements,$model);
	if(!$leaveWrongChars)
	{
		$model=str_replace($wrongChars,"_",$model);
	}

	if(isset($MODELSPACECHAR))
	{
		$model=str_replace(" ",$MODELSPACECHAR,$model);
	}

	return $model;
}



function deleteMissingTags()
{
	global $fullpath;
	global $MISSINGFILESSUFFIX;
	$suffixLen=strlen($MISSINGFILESSUFFIX);
	if($dir = opendir($fullpath))
	{
		while($file = readdir($dir))
		{
			if(substr($file,strlen($file)-$suffixLen)==$MISSINGFILESSUFFIX)
			{
				echo "$fullpath.$file";
				unlink($fullpath.$file);
			}
		}
		closedir($dir);
	}
}

function createMissingTags($missingFiles)
{
	global $fullpath;
	global $MISSINGFILESSUFFIX,$MISSINGFILESRIGHTS, $MISSINGFILESOWNER;
	global $SCRIPTPATH;
	global $aclFiles;

	list($owner,$group)=translateOwnerGrp($MISSINGFILESOWNER);

	foreach($missingFiles as $missingFile)
	{
		fclose(fopen($fullpath.$missingFile.$MISSINGFILESSUFFIX,"w+"));
		$aclFiles["releaseDir"]->chmod($missingFile.$MISSINGFILESSUFFIX,$owner,$group,$MISSINGFILESRIGHTS);
	}

	//	exec("{$SCRIPTPATH}chmod.exe $MISSINGFILESRIGHTS $owner $group \"$fullpath*$MISSINGFILESSUFFIX\"");
}

function splitOption($option)
{
	$returnArray=array();
	$openQuote=false;
	$currentWord="";

	$len=strlen($option);
	for($i=0;$i<$len;$i++)
	{
		switch($option[$i])
		{
		case " ":
		case "	":
			if($openQuote)
			{
				$currentWord.=$option[$i];
			}
			else
			{
				if($currentWord!="")
				{
					$returnArray[]=$currentWord;
					$currentWord="";
				}
			}
			break;
		case "\"":
			if($openQuote)
			{
				$returnArray[]=$currentWord;
				$currentWord="";
				$openQuote=false;
			}
			else
			{
				$openQuote=true;
			}
			break;
		default:
			$currentWord.=$option[$i];
		}
	}
	if($currentWord!="")
		$returnArray[]=$currentWord;
	return $returnArray;	
}

function initPathVars()
{
	global $aclFiles,$fullpath,$release,$multiCD,$MULTICDTEMPLATES;

	$multiCD=false;
	$release=basename($fullpath);

	$aclFiles["releaseDir"]=new AclFile($fullpath);
	$parentDir=dirname($fullpath);

	if(eregi($MULTICDTEMPLATES,$release))
	{
		$release=basename(dirname($fullpath))."_$release";
		$multiCD=true;
		$parentDir=dirname($parentDir);
	}

	$aclFiles["parentDir"]=new AclFile($parentDir."\\");
}

function simulateAnnouncement($announcementType)
{
	global $announcements;
	global $ANNOUNCEMINIMUM, $SMALLIESCOMPLETITION, $ALLOWSITEBOT, $ROMSCOMPLETITION;
	global $nbfiles, $username, $currentdir, $virtualpath, $usergroup;
	global $doNotAnnounce, $fullname, $lastSpeed, $nbfilesup;

	if(isset($doNotAnnounce) && $doNotAnnounce)
		return;

	switch($announcementType)
	{
	case "onSfvSuccess":
		// simulation of the onSfvSuccess event
		{

			if( $nbfiles >= $ANNOUNCEMINIMUM )
			{
				switch($ALLOWSITEBOT)
				{
				case 1:
					$fsize=round(filesize($fullname)/1024);
					$announcements[]=".sfv GOOD _ $username $usergroup ".$fsize ." \"$virtualpath\" $nbfiles \"$currentdir\" \"$lastSpeed||||\"";
					break;
				case 2:
					$announcements[]=".rdinfo fileup|$usergroup|$virtualpath|$nbfilesup|$nbfiles";
					break;
				case 3:
					$announcements[]=".info fileup|$usergroup|$virtualpath|$nbfilesup|$nbfiles";
					break;
				case 4:
					$announcements[]=".info fileup|$username|$usergroup|$virtualpath|$nbfilesup|$nbfiles|$lastSpeed";
					break;
				}
			}
			break;
		}

	case "onSfvComplete":
		// simulation of the onSfvComplete event
		{
			global $lastSpeed;
			if(	$nbfiles >= $ANNOUNCEMINIMUM
				|| ($SMALLIESCOMPLETITION && $nbfiles < $ANNOUNCEMINIMUM )
				|| (isset($ROMSCOMPLETITION) && $isRom) )
			{
				switch($ALLOWSITEBOT)
				{
				case 1:
					$announcements[]=".sfv DONE _ _ _ \"".trim($nbfiles)."\" \"$virtualpath\" \"$nbfiles\"";
					break;
				case 2:
					$announcements[]=".rdinfo complete|$username|$usergroup|$virtualpath|".date("Y/m/d H:i");
					break;
				case 3:
					$announcements[]=".info complete|$username|$usergroup|$virtualpath|".date("Y/m/d H:i");
					break;
				case 4:
					$announcements[]=".info complete|$username|$usergroup|$virtualpath|".date("Y/m/d H:i");
					break;
				}
			}
			break;
		}

	case "onSfvUploaded":
		// simulation of the onSfvUploaded event
		{
			if($nbfiles >= $ANNOUNCEMINIMUM)
			{
				switch($ALLOWSITEBOT)
				{
				case 1:
					$announcements[]=".sfv SFV _ $username _ 0 \"$virtualpath\" $nbfiles \"$currentdir\"";
					break;
				case 2:
					$announcements[]=".rdinfo update|$username|$usergroup|$virtualpath|$nbfiles";
					break;
				case 3:
					$announcements[]=".info update|$username|$usergroup|$virtualpath|$nbfiles";
					break;
				case 4:
					$announcements[]=".info update|$username|$usergroup|$virtualpath|$nbfiles";
					break;
				}
			}
			break;
		}
	}
}
?>