<?php
$SCRIPTPATH=str_replace("\\","/",realpath(dirname(__FILE__)))."/";

require("{$SCRIPTPATH}init.php");

if(!isset($argv))
{
	if(isset($_SERVER["argv"]))
		$argv=$_SERVER["argv"];
	else
	{
		addError("Unable to retrieve the arguments in ".__FILE__.". Make sure you have 'register_argc_argv=On' in you php.ini file!");
		exit();
	}
}

if(sizeof($argv) < 8)
{
	addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
	exit();
}

require("{$SCRIPTPATH}sfv.php");

$filename=basename($argv[1]);
$fullpath=dirname($argv[1])."\\";
$GCID=$argv[7];
/*if(!(isset($ALLOWDIZUPLOAD) && $ALLOWDIZUPLOAD!="") && filesize($fullpath.$filename)==0)
{
unlink($fullpath.$filename);
$message=" $filename \n";
$message.=" 0-byte file ---> deleted ";
outputProgress($message);
exit();
}*/
$extension=substr($filename,strrpos($filename,".")+1);
initPathVars();

// loading the chmod module


switch(strtolower($extension))
{
case "zip":
	break;
case "sfv":
	{
		if(isset($SFVCHECK) && $SFVCHECK > 0)
		{
			$sfvFileName=basename($argv[1]);
			$fullpath83=$argv[2];
			$username=$raceLeader=$argv[5];
			$usergroup=$leadingGroup=$leaderGroup=$argv[6];

			$sfv=analyseSfv($sfvFileName);

			$nbfiles=sizeof($sfv);

			onSfvUploaded(true);
		}
		break;
	}
default:
	{
		$lastSpeed=$argv[4];
		$username=$argv[5];
		$usergroup=$argv[6];

		$sfvFileName=findSfv();
		if(isset($SFVCHECK) && $SFVCHECK > 0)
		{
			if($sfvFileName!="")
			{
				$sfv=analyseSfv($sfvFileName);
				if(isset($sfv[strtolower($filename)]))
				{
					$fullpath83=$argv[2];
					$filename83=$argv[3];
					$nbfiles=sizeof($sfv);

					if(fastFileCheck($fullpath83.$filename83,$sfv[$filename]))
					{
						if(file_exists("{$fullpath}$filename.bad"))
						{
							unlink("{$fullpath}$filename.bad");
							$aclFiles["releaseDir"]->delete("$filename.bad");
						}
						onSfvSuccess(true);
					}
					else
					{
						onSfvFailed(true);
					}
				}
			}
			else
			{
				$filesize=filesize($fullpath.$filename);
				insert_file($release,$filename,$filesize,$lastSpeed,$username,$usergroup);
			}
		}
		else
		{
			if($sfvFileName=="")
			{
				$filesize=filesize($fullpath.$filename);
				insert_file($release,$filename,$filesize,$lastSpeed,$username,$usergroup);
			}
			else
			{
				if(file_exists("{$SCRIPTPATH}tmp\\$filename.$GCID.bad"))
				{
					@unlink("{$SCRIPTPATH}tmp\\$filename.$GCID.bad");
				}
			}
		}
	}
}

?>