<?php
$SCRIPTPATH=str_replace("\\","/",realpath(dirname(__FILE__)))."/";

require("{$SCRIPTPATH}init.php");

if(!isset($argv))
{
	if(isset($_SERVER["argv"]))
		$argv=$_SERVER["argv"];
	else
	{
		addError("Unable to retrieve the arguments in ".__FILE__.". Make sure you have 'register_argc_argv=On' in you php.ini file!");
		exit();
	}
}

if(sizeof($argv) < 9)
{
	addError("The script did not receive enough arguments in ".__FILE__.". Make sure your settings are OK in your .ftpd file");
	exit();
}

//if(isset($ALLOWSITEBOT))
//	require("{$SCRIPTPATH}eggtalk.php");

$filename=strtolower($argv[2]);

$fullpath83=$argv[3];
$filename83=$argv[4];
$fullpath=$fullpath83;
initPathVars();
$release=substr(strrchr($argv[1],"/"),1);
$fullname=$fullpath83."\\".$filename83;

$username = $argv[5];
$usergroup = $argv[6];
$lastSpeed = $argv[7];

$tagline = $argv[8];
$virtualpath = $argv[1]."/".$argv[2];
$currentdir = $argv[1];

$GCID = $argv[9];

outputProgress(" looks like there was an error !!! \n check {$SCRIPTPATH}errors.log ","w+");

if(isset($ZIPCHECK) && $ZIPCHECK>0)
{
	if(isset($ZIPFIXING) && $ZIPFIXING>0)
	{
		if($ZIPFIXING==1)
			$moreargs="-F";
		if($ZIPFIXING==2)
			$moreargs="-FF";
	}
	else
		$moreargs="";

	exec("\"{$SCRIPTPATH}zip.exe\" -T -q $moreargs {$fullpath83}$filename83",$foo,$returnVal);
	if($returnVal!=0)
	{
		switch($ZIPCHECK)
		{
		case 2:
			{
				outputProgress(" $filename is bad. \n File deleted","w+");
				unlink($fullname);
				die();
				break;
			}
		case 3:
			{

			}
		default:
			{
				outputProgress(" $filename is bad. \n Renamed to $filename.bad and zeroed ","w+");
				unlink($fullname);
				fclose(fopen("$fullname.bad","w+"));
				$aclFiles["releaseDir"]->rename($filename,"$filename.bad");
				die();
				break;
			}
		}
	}
}

if(file_exists("$fullname.bad"))
unlink(file_exists("$fullname.bad"));

$filesize=filesize($fullpath.$filename);
insert_file($release,$filename,$filesize,$lastSpeed,$username,$usergroup);


if(isset($ROMSPATH))
{
	foreach($ROMSPATH as $dirn)
	{
		if($dirn != "")
		{
			if(stristr($currentdir,str_replace("\\","/",$dirn)))
			{
				require("zip.php");
				zipcheck(true);

				if(!$doNotAnnounce && sizeof($announcements)!=0)
				{
					announce();
				}
				die();
			}
		}
	}
}

if(isset($RIPPATH))
{
	foreach($RIPPATH as $dirn)
	{
		if($dirn != "")
		{
			if(stristr($currentdir,str_replace("\\","/",$dirn)))
			{
				require("zip.php");
				zipcheck(false);

				if(!$doNotAnnounce && sizeof($announcements)!=0)
				{
					announce();
				}
				die();
			}
		}
	}
}

$outputStr=" phpZipScript is not configured for this section
$filename accepted... ";
outputProgress($outputStr,"w+");
?>