<?php
function zipcheck($isRom)
{
	global $fullname, $fullpath, $filename,$fullpath83,$filename83;
	global $username, $usergroup, $lastSpeed, $release;
	global $SCRIPTPATH, $ZIPCHECK, $NFOLIST, $ZIPCLEANING, $COMMENTFILE, $SITENFO;
	global $GCID, $EXTRACTEDFILESRIGHTS, $COMPLETEMODEL, $INCOMPLETEMODEL, $PARENTINCOMPLETEMODEL;
	global $nbfiles,$nbfilesup, $percent;

	////////////////////////// zip processing ////////////////////////////////////////////
	// diz,nfo extraction + zipcleaning
	$dir = opendir($fullpath);

	if(!file_exists("{$fullpath}file_id.diz"))
		$missingsNeeded=true;
	else
		$missingsNeeded=false;

	while($file = readdir($dir))
	{
		$filesInDir[]=strtolower($file);
	}
	closedir($dir);

	$cmd="\"{$SCRIPTPATH}unzip.exe\" -Z -1 {$fullpath83}$filename83";
	exec($cmd,$result);

	foreach($result as $file)
	{
		if($file=="")
		{
			continue;
		}

		$bool=in_array(strtolower($file),$filesInDir);
		if( !$bool || ( $bool && filesize($fullpath.$file)!=0))
		{
			if(strtolower($file) == "file_id.diz")
			{
				$toExtract[]=$file;
			}
			else
			{
				$pos=strrpos($file,".");
				$base=strtolower(substr($file,0,$pos));
				$ext=strtolower(substr($file,$pos+1));

				$NFOLIST=loadUnwelcomedList();

				if(!eregi($NFOLIST,strtolower($file),$regs))
				{
					if($ext == "nfo")
					{

						$toExtract[]="$file";
					}
				}
				else
				{
					$trash=false;
					foreach($regs as $reg)
					{
						if(strtolower($reg)==strtolower($file))
						{
							$toTrash[]="\"$file\"";
							$trash=true;
						}
					}
					if($ext ==  "nfo" && !$trash)
					{
						$toExtract[]="$file";
					}

				}
			}
		}
	}

	if(isset($toExtract))
	{
		$cmd="\"\"{$SCRIPTPATH}unzip.exe\" -n -C {$fullpath83}$filename83 " . implode(" ",$toExtract) ." -d $fullpath83\"";
		exec($cmd);

		global $aclFiles;
		$aclFiles["releaseDir"]->addFiles($toExtract,$username,$usergroup,$EXTRACTEDFILESRIGHTS);
		/*
		foreach($toExtract as $key=>$file)
		{
		$cmd="\"\"{$SCRIPTPATH}chmod.exe\" $EXTRACTEDFILESRIGHTS $username $usergroup \"{$fullpath}$file\"\"";
		chmod("{$fullpath}$file",0777);
		exec($cmd);
		$toExtract[$key]="\"$file\"";
		}
		*/
	}

	if($ZIPCLEANING && isset($toTrash))
	{
		$cmd="\"\"{$SCRIPTPATH}zip.exe\" -d {$fullpath83}$filename83 " . implode(" ",$toTrash)."\"";
		exec($cmd);
	}

	if(isset($SITENFO))
	{
		$cmd="\"\"{$SCRIPTPATH}zip.exe\" -9 -j {$fullpath83}$filename83 $SITENFO\"";
		exec($cmd);
	}

	if(isset($COMMENTFILE) && file_exists($COMMENTFILE))
	{
		if($COMMENTFILE!="nul")
		{
			$comment=file($COMMENTFILE);

			$tempComment="./tempComment.$GCID";

			$fp=fopen($tempComment,"w+");

			fwrite($fp,"@ (zip file comment below this line)\r\n");
			fwrite($fp,implode("",$comment));
			fclose($fp);
			$cmd="\"{$SCRIPTPATH}zipnote.exe\" -w {$fullpath83}$filename83 < $tempComment";
			exec($cmd);
			@unlink($tempComment);
		}
		else
		{
			$cmd="\"{$SCRIPTPATH}zipnote.exe\" -w {$fullpath83}$filename83 < nul";
			exec($cmd);
		}
	}
	verifNbFile($isRom);

	update_release_nbfiles($release,$nbfiles);

	process_raceinfo();

	global $doNotAnnounce;
	$doNotAnnounce=false;

	if($nbfilesup>$nbfiles)
	{
		$nbfiles=$nbfilesup;
		$doNotAnnounce=true;
	}

	if($percent=="")
	{
		$percent = 0;
	}


	if($nbfilesup == 1)
	{
		simulateAnnouncement("onSfvUploaded");
	}

	simulateAnnouncement("onSfvSuccess");

	if(trim($percent) >= 100)
	{
		simulateAnnouncement("onSfvComplete");
	}

	// AMELIORER LE CODE !
	global $CREATEMISSINGFILES;
	if(isset($CREATEMISSINGFILES) && $CREATEMISSINGFILES!="" && $nbfiles > 1)
	{
		global $MISSINGFILESSUFFIX;
		$MISSINGFILESSUFFIX=str_replace(array("\\","/","*",":","?","\"","<",">","|"),"_",$MISSINGFILESSUFFIX);
		if(!isset($MISSINGFILESSUFFIX) || $MISSINGFILESSUFFIX=="")
			$MISSINGFILESSUFFIX="-missing";

		if(!$missingsNeeded)
		{
			if($nbfilesup>=$nbfiles)
			{
				deleteMissingTags();
			}
			else
			{
				@unlink("$fullpath{$filename}$MISSINGFILESSUFFIX");
				global $aclFiles;
				$aclFiles["releaseDir"]->delete($filename.$MISSINGFILESSUFFIX);
			}
		}
		else
		{
			$firstFileBase=substr($filename,0,-6)."01";
			$missingFiles=findMissingZipFiles($firstFileBase,$nbfiles);
			if(sizeof($missingFiles) == $nbfiles)
			{
				$firstFileBase=substr($filename,0,-5)."1";
				$missingFiles=findMissingZipFiles($firstFileBase,$nbfiles);
				if(sizeof($missingFiles) == $nbfiles)
				{
					$firstFileBase=substr($filename,0,-5)."a";
					$missingFiles=findMissingZipFiles($firstFileBase,$nbfiles);
					if(sizeof($missingFiles) == $nbfiles)
						$missingFiles=array();
				}
			}
			createMissingTags($missingFiles);
		}
	}
}

function verifNbFile($isRom)
{
	global $fullpath;
	global $usergroup;
	global $filename;
	global $release;
	global $nbfilesup;
	global $nbfiles;
	global $checktype;
	global $SITENAME;

	if($isRom)
	{
		$nbfiles=1;
	}
	else
	{
		if(!file_exists("{$fullpath}file_id.diz"))
		{
			$output=" $filename has no file_id.diz... ";
			outputProgress($output,"w+");
			global $NOFILEIDMODEL;
			createTag($fullpath.$NOFILEIDMODEL,4);
			die();
		} 
		else
		{
			if(!stristr($release,"diz.fix"))
			{
				$nbfiles=0;
				$ReadAllTextFile=join(file($fullpath."file_id.diz"),"\n");
				$pattern="[^/](\*{2}|0x|[0-9]{2}|x{2}|o[0-9]{1}|\[ x)[x/\\]([0-9]{2}|x{2}|o[0-9]{1}|[0-9]{1}o)[^/0-9]";
				if(eregi($pattern,$ReadAllTextFile,$regs))
				{
					$nbfiles=str_replace("o","0",substr($regs[0],4,2));
				}
				else
				{
					$pattern="\[(x{2}|[0-9]{1}|[xo]{1})[/][0-9]{1}\]";

					if(eregi($pattern,$ReadAllTextFile,$regs))
					{
						$tempstr=strstr($regs[0],"/");
						$nbfiles=substr($tempstr,1,strlen($tempstr)-2);
					}
				}
			}
			else
			{
				$nbfiles=1;
			}
		}
	}

	$nbfiles*=1;
	if(!$nbfiles)
	{
		global $DELETEBADFILEID;
		if(isset($DELETEBADFILEID))
		{
			unlink("{$fullpath}file_id.diz");
		}

		$output=" can't understand this file_id.diz... ";
		outputProgress($output,"w+");

		global $BADFILEIDMODEL;
		createTag($fullpath.$BADFILEIDMODEL,4);
		die();
	}
}

function findMissingZipFiles($firstZipBase,$nbfiles)
{
	global $fullpath;
	$currentFile=$firstZipBase;
	$missingFiles=array();
	for($i=0;$i<$nbfiles;$i++)
	{
		if(!file_exists("{$fullpath}$currentFile.zip"))
		{
			$missingFiles[]=$currentFile.".zip";
		}
		$currentFile++;
	}
	return $missingFiles;
}
?>